// Wormhout10Chain9.pde
// OuvertureXml.pde
// Chain.pde
// 
// Gerard Paresys Guy Kayser
// 14 1 2015
// Processing 2.0.3
//
// A partir de http://www.openprocessing.org/sketch/77718
// "Worm" de Adam Lastowka
// "A worm, building a landscape by "tunneling" all over it, raising and lowering the terrain.
// Somewhat like the sandworms in "Dune" by Frank Herbert..."
//
// Utilise la library minim incluse dans Processing 2
// http://code.compartmental.net/minim/
//
// Utilise la "contributed library" peasycam by Jonathan Feinberg
// http://mrfeinberg.com/peasycam/
//
// PeasyCam: Souris Molette           : Zoom
//           Souris Clic droit + Drag : Zoom      
//           Souris Clic + Drag       : Rotation      
//           Souris 2 x Clic          : Reset position
//           Souris cmd + Clic + Drag : Translate (MacOS)
// Touche Clavier:
//       E Erosion Lissage
//       Z Retour au debut
//       R Rouge Couleur relief On / Off
//       V Vert  Couleur relief On / Off
//       B Bleu  Couleur relief On / Off
//       C       Couleur Worm   On / Off
//       S Sauve l'ecran (format png) "maore-123.png" 123 = Numero frame
//       L Lumiere              On/Off
//       T Affiche Transcription <-> Traduction
//  Espace Pause
//
// Si le dossier data contient 5 fichiers nommés:
//   XXX.xml  (format Praat TextGrid sauve en UTF8)
//   XXX.mp3
//   XXX_Pitch.txt
//   XXX_Intensity.txt
//   XXX256.png  256x256 pixels
// le sketch les ouvre
// sinon un selecteur de fichiers s'ouvre, choisir alors un fichier XXX.xml...
// Modifier la ligne 53 au besoin
//
// Le dossier data doit aussi contenir les fichiers:
//   Aller-Light-120.vlw
//

import ddf.minim.*;         // pour AudioPlayer
import peasy.*;

String  NomFichierXML = "maoree.xml"; // les 5 fichiers "maore..." doivent etre dans le dossier data

boolean Lumiere       = true;  // Touche L  Lumiere On/Off
boolean TransTrad     = true;  // Touche T Affiche Transcription <-> Traduction
Boolean WormEnCouleur = false;
boolean Verbose       = false;
Boolean HeigtMapEnCouleurR = false;
Boolean HeigtMapEnCouleurV = false;
Boolean HeigtMapEnCouleurB = false;

color   CouleurBackground = color(0); // Noir
// color   CouleurShape      = color(255, 100);    // 
color   CouleurTexteRuban = color(255, 255, 255);  // Vert: color(0, 255, 0)
color   CouleurTexteBas   = color(255, 255, 255);  // Rouge: color(255, 0, 0)
color   CouleurWorm       = color(255, 0, 0);      // Rouge: color(255, 0, 0)

int RubanMini= 10;
int RubanMaxi= 80;

XML[] Traduction, Transcription;
int NombreSegment;
String[] LignesPitch;
String[] LignesIntensity;
float[] LignePitch, LigneIntensity;
boolean FichierOuvert = false;

Minim minim;
AudioPlayer player;

PeasyCam pcam;

float[][] hm  = new float[256][256]; // hm[x][y] = brightness(Image)
float[][] hm2 = new float[256][256];
int hmlengthdemi = hm.length / 2;

float MM = 2;         // MM = diametre du worm
//float  M = random(2,7.634);          // zone flou autour worm
boolean Pause = false;
float Temps, TempsPause = 0, TempsDebutPause = 0;
PFont  FontTexte, FontRuban;


Maker Worm = new Maker(); 
float wormTemp;
int   x, y, Alea;
float Distance, h;

PImage Image1;
color MonPixel;

int IndexXML = 0, Segment;
float xmin, xmax;  // Temps en seconde
String Content1 = "", Content2 = "", Content = "", Nom = "";
float Intensite, Pitche = 100, PitcheMini = 1000, PitcheMaxi = 0;
float  FacteurIntensity, FacteurPitch;


void setup() {  
  // size(800, 600, P3D);  // P3D  OPENGL
  size(1024, 768, P3D); // P3D  OPENGL
  frame.setBackground(new java.awt.Color(0, 0, 0));

  // Image1 = loadImage(NomFichierCarte);
  // background(Image1);
  // image(Image1, 0, 0, width, height);

  // pcam = new PeasyCam(this, width/2, height/2, 0, 500); // PeasyCam(PApplet parent, double lookAtX, double lookAtY, double lookAtZ, double distance);
  // 500 * 2 / 1.6 = 625
  pcam = new PeasyCam(this, width/2, height/2, 0, 600); // PeasyCam(PApplet parent, double lookAtX, double lookAtY, double lookAtZ, double distance);
  pcam.setMinimumDistance(50);
  pcam.setMaximumDistance(1000);
  pcam.rotateX(-PI/4);

  noStroke();
  frameRate(60);

  // frameRate(2); // A mettre pour mieux comprendre
  // maFonte = createFont("AdventPro-Thin", 12);
  // maFonte = createFont("Georgiazut", 18);
  // FontTexte = loadFont("ArialMT-12.vlw");
  // maFonte = createFont("Arial", 12);
  FontTexte = createFont("Arial", 12);
  FontRuban = loadFont("Aller-Light-120.vlw"); // Font taille 120

  // println("hm.length = " + hm.length);

  // Chain ------------------------------------------------------------------------
  // Ruban = loadStrings("kokot.txt");
  Ruban = "A";
  reversed = reverseWords(Ruban);
  chain = new ArrayList();
  // chain = ("");
  for (int i = 0; i < num; i++) chain.add(new Chain(i));
  // Chain ------------------------------------------------------------------------

  File Fichier = new File(dataPath(NomFichierXML));
  if (Fichier.exists()) {
    Ouverture(NomFichierXML);
    Nom = split(Fichier.getName(), '.')[0];
  }
  else selectInput("select the XML File (format Praat textGrid):", "fileSelected");
}

void draw() {
  background(CouleurBackground);  // 0 
  // image(Image1, 0, 0);
  // image(Image1, 0, 0, width, height);
  if (Lumiere) lights();

  if (! Pause) Temps = (millis() - TempsPause) / 1000.0; //temps en ms

  if (FichierOuvert) {

    if (IndexXML < (NombreSegment-1)) {
      if (Temps > xmax) {                        // Passage au segment suivant
        IndexXML = IndexXML + 1;
        Content = Traduction[IndexXML].getContent();
        Content2 = Transcription[IndexXML].getContent();
        if (Verbose) println();
        if (Verbose) println("IndexXML = " + IndexXML);
        if (Content == null) IndexXML = IndexXML + 1;
        else if (Content.equals("_") == true) IndexXML = IndexXML + 1;//Elimination des caracteres _ qui separe les segments
        // else if ((Temps > xmin) && ! Pause) {
        else if (! Pause) {
          Segment = Traduction[IndexXML].getInt("n"); 
          xmin = Traduction[IndexXML].getFloat("xmin");
          xmax = Traduction[IndexXML].getFloat("xmax");
          Content1 = trim(Content);
          Content2 = trim(Content2);
          println(Content1);
          println(Content2);
          // Chain ------------------------------------------------------------------------
          // Ruban = loadStrings("kokot.txt");
          // Ruban = Content2;
          // Ruban = "0123456789012345678901234567890123456789";
          if (TransTrad) Ruban = Content1;    // Traduction
          else           Ruban = Content2;    // Transcription
          reversed = reverseWords(Ruban);
          chain = new ArrayList();         // Efface chain
          for (int i = 0; i < num; i++) chain.add(new Chain(i));
          // Chain ------------------------------------------------------------------------
        }
      }
    }
    else Pause = true;

    if (Temps < LignesIntensity.length) {
      LigneIntensity = float(split(LignesIntensity[int(Temps * FacteurIntensity)], "   "));
      Intensite = LigneIntensity[1];
      Intensite = (Intensite - 40) / 12;
      Intensite = max(Intensite, 0);
      // println("Temps = " + Temps + "      Intensite = " + Intensite);
    }

    if (Temps < LignesPitch.length) { //le retour du pitch voir Corpus35P2.pde
      LignePitch = float(split(LignesPitch[int(Temps * FacteurPitch)], "   "));
      if (! Float.isNaN(LignePitch[0]) && ! Float.isNaN(LignePitch[1])) Pitche = LignePitch[1];
      //  if (Pitche < PitcheMini) PitcheMini = Pitche;
      //  if (Pitche > PitcheMaxi) PitcheMaxi = Pitche;
      //  println("PitcheMini = " + PitcheMini + "   PitcheMaxi = " + PitcheMaxi);
      //  println("Temps = " + Temps + "      LignePitch[0] = " + LignePitch[0] + "   Pitche = " + Pitche);
      MM = ((Pitche - 75) / 85) + 2; // 2 .. 7
      // println("MM = "+ MM);
    }

    pushMatrix();
    translate(width/2, height/2);
    if (! Pause) {   
      temGen();
    }
    paintLandscape();
    // Lissage();
    textFont(FontTexte, 12); 
    fill(CouleurTexteBas); // fill(0, 255, 0); // Texte vert
    textAlign(CENTER);
    translate(-200, 0, 30); //translate(-200, 0, 60)
    // text(Content2, 0, 220, 400, 100 ); // Transcription
    if (TransTrad) text(Content2, 0, 260, 400, 100); // Transcription
    else text(Content1, 0, 260, 400, 100);          // Traduction
    popMatrix();

    // Chain ------------------------------------------------------------------------
    pushMatrix();
    // translate(0, 0, 70);
    translate(Worm.x, Worm.y, Intensite + 35);
    // noStroke(); // Commenter pour voir le dessin du ruban
    if (! Pause) {
      for (int i =0 ; i < chain.size();i++) {
        Chain cc  = (Chain)chain.get(i);
        cc.update();
      }
    }
    for (int i =chain.size()-1 ; i > 0 ;i--) {
      Chain cc  = (Chain)chain.get(i);
      cc.draww();
    }

    popMatrix();
    // Chain ------------------------------------------------------------------------
  }

  frame.setTitle(Nom + "     " + int(Temps * 10) / 10.0 + " sec     " + int(10 * frameRate) / 10.0 + " fps");
}

void keyPressed() {
  if ( key == ' ') {  // barre d'espace Pause
    Pause = !Pause;
    if (Pause) {
      player.pause();
      TempsDebutPause = millis();
    }
    else {
      player.play();
      TempsPause = TempsPause + millis() - TempsDebutPause;
    }
  }
  else if ( key == 'e' || key == 'E' ) Lissage(); // Erosion Lissage
  else if ( key == 'z' || key == 'Z' ) {
    generateLandscape();
    Lissage();
    Lissage();
    xmax = 0;
    IndexXML = -1;
    Pause = false;
    TempsPause = millis();
    PlayerAudioDebut();
  }
  else if ( key == 'c' || key == 'C' ) WormEnCouleur = !WormEnCouleur;  // Touche C  Worm en couleur On/Off
  else if ( key == 's' || key == 'S' ) saveFrame(Nom + "-" + frameCount + ".png");
  else if ( key == 'l' || key == 'L' ) Lumiere = !Lumiere;     // Touche L  Lumiere On/Off
  else if ( key == 't' || key == 'T' ) TransTrad = !TransTrad; // Touche T  Affiche Transcription <-> Traduction
  else if ( key == 'r' || key == 'R' ) HeigtMapEnCouleurR = !HeigtMapEnCouleurR; // Heightmap Vert
  else if ( key == 'v' || key == 'V' ) HeigtMapEnCouleurV = !HeigtMapEnCouleurV; // Heightmap Vert
  else if ( key == 'b' || key == 'B' ) HeigtMapEnCouleurB = !HeigtMapEnCouleurB; // Heightmap Vert
}

void generateLandscape() {
  Image1 = loadImage(NomFichierCarte);
  Image1.loadPixels();
  HeightMap();
  // for (int i = 0; i < 600; i++) temGen();
}

void HeightMap() {
  for ( x = 0; x < hm.length; x++) {
    for ( y = 0; y < hm.length; y++) {
      // hm[x][y] = 0;
      // hm[x][y] = brightness(Image1.pixels[x + (y * hm.length)])/ 255.f;
      // hm[x][y] = brightness(Image1.pixels[x*4 + (y*4*3 * hm.length)])/ 25.f;
      hm[x][y] = brightness(Image1.pixels[x + (y * hm.length)])/ 8.f;
      // println(brightness(Image1.pixels[x*4 + (y*4*3 * hm.length)])/ 25.f);
      // if (x == 128) {
      // println("generateLandscape  hm[128]["  + y + "] = " + hm[128][y] + "  Distance = " + Distance);
      // }
    }
  }
  // for (int i = 0; i < 600; i++) temGen();
}

void temGen() {
  // - hmlengthdemi < Worm.x < + hmlengthdemi
  // - hmlengthdemi < Worm.yx < + hmlengthdemi
  //  Worm.x += sin(Worm.wormTheta)*2;
  //  Worm.y += cos(Worm.wormTheta)*2;
  Worm.x += sin(Worm.wormTheta);
  Worm.y += cos(Worm.wormTheta);
  Worm.wormTheta += Worm.wormThetaDelta;
  Worm.wormThetaDelta += random(-0.1, 0.1);
  // Worm.wormThetaDelta /= 1.05; 
  Worm.wormThetaDelta /= 1.50; // 1.30 // 1.05 le worm tourne beaucoup 1.25 tourne peu 
  if      (Worm.x >   hmlengthdemi - 10) Worm.wormTheta = Worm.wormTheta - HALF_PI;
  else if (Worm.x < - hmlengthdemi + 10) Worm.wormTheta = Worm.wormTheta - HALF_PI;
  else if (Worm.y >   hmlengthdemi - 10) Worm.wormTheta = Worm.wormTheta - HALF_PI;
  else if (Worm.y < - hmlengthdemi + 10) Worm.wormTheta = Worm.wormTheta - HALF_PI;

  // Alea = int(random(hm.length));

  x = int(Worm.x + hmlengthdemi);
  y = int(Worm.y + hmlengthdemi);
  h = Intensite * 3.9; // 4.4
  //h = Intensite * 13.0;
  // h = 20;
  hm[x][y] = hm[x][y] + h*1.5;
  x = x - 1;
  hm[x][y] = hm[x][y] + h;
  x = x + 2;
  hm[x][y] = hm[x][y] + h;
  x = x - 1;
  y = y - 1;
  hm[x][y] = hm[x][y] + h;
  y = y + 2;
  hm[x][y] = hm[x][y] + h;

  for ( x = 1; x < hm.length-1; x++) {
    for ( y = 1; y < hm.length-1; y++) {

      Distance = dist((x - hmlengthdemi) / MM, (y - hmlengthdemi) / MM, Worm.x / MM, Worm.y / MM);

      if (Distance < 3) {
        hm2[x][y] = (hm[x][y]*2 + hm[x+1][y] + hm[x-1][y] + hm[x][y+1] + hm[x][y-1]) / 5.9315;
        // hm2[x][y] = (hm[x][y]*2 + hm[x+1][y] + hm[x-1][y] + hm[x][y+1] + hm[x][y-1])/5.9378;//kabyle-2172.png,guadeloupe-2118.png
        // hm2[x][y] = (hm[x][y]*2 + hm[x+1][y] + hm[x-1][y] + hm[x][y+1] + hm[x][y-1])/5.9278;//baude_fr-1971.png
        // hm2[x][y] = (hm[x][y]*2 + hm[x+1][y] + hm[x-1][y] + hm[x][y+1] + hm[x][y-1])/6;

        // Image1.pixels[x + (y * hm.length)] = color(hm2[x][y] * 8);
        // Image1.pixels[x + (y * hm.length)] = color((hm2[x][y] * 8)+255, (hm2[x][y] * 8), (hm2[x][y] * 8));
        // Image1.pixels[x + (y * hm.length)] = color((hm2[x][y] *8), 0, 0);
        // Image1.pixels[x + (y * hm.length)] = color((hm2[x][y] * 16), (hm2[x][y] * 8), (hm2[x][y] * 8));

        //if (WormEnCouleur)  Image1.pixels[x + (y * hm.length)] = color(red(MonPixel)+random(255), green(MonPixel)+random(255), blue(MonPixel)+random(255),150);
        if (WormEnCouleur) Image1.pixels[x + (y * hm.length)] = color(0, (hm2[x][y] *8), 0);
        else Image1.pixels[x + (y * hm.length)] = color(hm2[x][y] * 8);
      }
    }
  }
  for ( x = 1; x < hm.length-1; x++) {
    for ( y = 1; y < hm.length-1; y++) {

      Distance = dist((x - hmlengthdemi) / MM, (y - hmlengthdemi) / MM, Worm.x / MM, Worm.y / MM);
      if (Distance < 3) {
        hm[x][y] = hm2[x][y];
      }
    }
  }

  // HeightMap();
  // Image1.updatePixels();
  // Lissage();
}

void paintLandscape() {
  // stroke(128);
  noStroke();
  // fill(0,0,255); 
  scale(1.8);
  for ( x = 3; x < hm.length-5; x++) {
    beginShape(QUADS);
    for ( y = 3; y < hm.length-5; y++) {
      //fill(abs(4*hm[x][y]), 255, 255);//origin
      if (HeigtMapEnCouleurR) fill((hm2[x][y]*8), (hm2[x][y] *2), (hm2[x][y]*2));//RVB
      else if (HeigtMapEnCouleurV) fill((hm2[x][y]*2), (hm2[x][y] *8), (hm2[x][y]*2));//RVB
      else if (HeigtMapEnCouleurB) fill((hm2[x][y]*2), (hm2[x][y] *2), (hm2[x][y]*16));//RVB
      // fill(232, 220, 108);
      else fill(Image1.pixels[x + (y * hm.length)]);
      vertex(x     - hmlengthdemi, y     - hmlengthdemi, hm[x]  [y]);
      vertex(x + 1 - hmlengthdemi, y     - hmlengthdemi, hm[x+1][y]);
      vertex(x + 1 - hmlengthdemi, y + 1 - hmlengthdemi, hm[x+1][y+1]);
      vertex(x     - hmlengthdemi, y + 1 - hmlengthdemi, hm[x]  [y+1]);
    }
    endShape(CLOSE);
  }
  scale(0.5);
}


void Lissage() {
  //    for(float x = 1; x < hm.length-1; x++) {
  //        for(float y = 1; y < hm.length-1; y++) {
  //          hm[(int)x][(int)y] = (hm[(int)x][(int)y]*2 + hm[(int)x+1][(int)y] + hm[(int)x-1][(int)y] + hm[(int)x][(int)y+1] + hm[(int)x][(int)y-1])/6;
  //        }
  //    }

  for ( x = 1; x < hm.length-1; x++) {
    for ( y = 1; y < hm.length-1; y++) {
      hm2[x][y] = (hm[x][y]*2 + hm[x+1][y] + hm[x-1][y] + hm[x][y+1] + hm[x][y-1])/6;
    }
  }
  for ( x = 1; x < hm.length-1; x++) {
    for ( y = 1; y < hm.length-1; y++) {
      hm[x][y] = hm2[x][y];
    }
  }
  println("Lissage");
}


class Maker {
  float x;
  float y;
  float wormTheta;
  float wormThetaDelta;
}

void FinOuverture() {
  minim = new Minim(this);
  player = minim.loadFile(NomFichierAudio, 1024);
  FichierOuvert = true;
  xmax = 0;
  IndexXML = -1;
  FacteurIntensity = LignesIntensity.length / LigneIntensity[0]; //Nombre de lignes / Duree totale fichier XXX_Intensity.txt 
  FacteurPitch = LignesPitch.length / LignePitch[0]; //Nombre de lignes / Duree totale fichier XXX_Intensity.txt 
  Lissage();
  Lissage();
  player.play();
  TempsPause = millis();
}

void PlayerAudioDebut() {
  player.close();
  player = minim.loadFile(NomFichierAudio, 1024);
  player.play();
  TempsPause = millis();
}

